/*
 *  file      : src/ntb_generate.c
 *  project   : b2im
 *  copyright : (C) 2015 by BULIN Claude
 * 
 *  This file is part of b2im project
 * 
 *  b2im is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; version 3.
 * 
 *  b2im is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */
 
// ---------------------------------------
// #define NOTEBOOK_INIT_PACKAGES	0
// #define NOTEBOOK_DESKTOP			1
// #define NOTEBOOK_KERNEL			2
// #define NOTEBOOK_PACKAGE			3
// #define NOTEBOOK_GFXBOOT			4
// #define NOTEBOOK_TO_HOME			5
// #define NOTEBOOK_GENERATE		6 <---
// ---------------------------------------

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gstdio.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_b2im/lib.h"
#endif

#include "global.h"
#include "configuser.h"




typedef struct {
	gchar	*manjaro_tools_conf;
	gchar	*manjaro_tools_conf_old;
	gchar	*profil_conf;
	gchar	*profil_conf_old;
	gchar	*dirname;
	guint	handler_timeout;
} VAR_GENERATE;

VAR_GENERATE VarGenerate;



void NtbGenerate_thread_iso_file( void )
{
	FILE	*fp;
	
	// DESKTOP
	// Save file + data
	NtbPackage_save_list();
	
	// ACTION TO NEW GFXBOOT
	NtbGfxBoot_gfxboot_action();
	
	// Save datas to $HOME, $HOME/.config, $HOME/.local/share
	NtbHome_save_datas_to_home_();
	
	// ACTION BUILDISO
	printf("%s*-*-> Begin action: buildiso%s\n", BOLD_YELLOW, RESET );
	chdir( Config.path_folder_manjaro_profiles );
	fp = fopen( "/tmp/run_buildiso.sh", "w" );
	fprintf( fp, "#!/bin/bash\n" );
	fprintf( fp, "#\n\n" );
	fprintf( fp, "cd %s\n", Config.path_folder_manjaro_profiles );
	fprintf( fp, "echo -e \"\033[1;33m\"\n" );
	fprintf( fp, "echo !\n" );
	fprintf( fp, "echo !-----------------------------------------------\n" );
	fprintf( fp, "echo ! Enter root password please for:\n" );
	fprintf( fp, "echo \"!   sudo buildiso -p %s\"\n", NtbDesktop_get_desktop_actif() );
	fprintf( fp, "echo !-----------------------------------------------\n" );
	fprintf( fp, "echo !\n" );
	fprintf( fp, "echo -e \"\033[0m\"\n" );
	fprintf( fp, "sudo buildiso -p %s\n", NtbDesktop_get_desktop_actif() );
	fprintf( fp, "\n" );
	fclose( fp );
	g_chmod( "/tmp/run_buildiso.sh", 0700 );   
	system( "/tmp/run_buildiso.sh" );
	// call_with_args( 
	// 			STDOUT_FILENO,
	// 			"/tmp/run_buildiso.sh",
	// 			NULL
	// 			);
	g_unlink( "/tmp/run_buildiso.sh" );
	chdir( VarGenerate.dirname );
	printf("%s*-*-> End action: buildiso%s\n", BOLD_YELLOW, RESET );
	
	pulse_stop();
}
// 
// 
void NtbGenerate_timeout_begin( void )
{
	FILE	*fp 					= NULL;

	VarGenerate.manjaro_tools_conf		= g_strdup_printf( "%s", Config.pathname_manjaro_tools_iso_profiles );
	VarGenerate.manjaro_tools_conf_old	= g_strdup_printf( "%s.OLD", VarGenerate.manjaro_tools_conf );
	VarGenerate.profil_conf				= g_strdup_printf( "%s/%s/profile.conf", Config.path_folder_manjaro_profiles, NtbDesktop_get_desktop_actif() );
	VarGenerate.profil_conf_old			= g_strdup_printf( "%s.OLD", VarGenerate.profil_conf );
	VarGenerate.dirname					= g_get_current_dir();

	// PROFIL.CONF
	printf("%s*-*-> Save file: %s%s\n", BOLD_YELLOW, VarGenerate.profil_conf, RESET );
	// Save file
	libutils_copy_file_to(
			VarGenerate.profil_conf,
			FALSE,
			VarGenerate.profil_conf_old
			);
	// Save data
	printf("%s*-*-> Save data: %s%s\n", BOLD_YELLOW, VarGenerate.profil_conf, RESET );
	fp = fopen( VarGenerate.profil_conf, "a" );
	fprintf( fp, "\n\n" );
	fprintf( fp, "kernel=\"%s\"\n", gtk_combo_box_text_get_active_text( GTK_COMBO_BOX_TEXT(GLADE_GET_OBJECT("combobox_choice_kernel")) ));
	fclose( fp );
	
	// MANJARO-TOOLS.CONF
	printf("%s*-*-> Save file: %s%s\n", BOLD_YELLOW, VarGenerate.manjaro_tools_conf, RESET );
	// Save file
	libutils_copy_file_to(
			VarGenerate.manjaro_tools_conf,
			FALSE,
			VarGenerate.manjaro_tools_conf_old
			);
	// Save data
	printf("%s*-*-> Save data: %s%s\n", BOLD_YELLOW, VarGenerate.manjaro_tools_conf, RESET );
	fp = fopen( VarGenerate.manjaro_tools_conf, "a" );
	fprintf( fp, "\n\n" );
	fprintf( fp, "chroots_pkg=%s/cache/buildpkg\n", Config.path_cache_iso );
	fprintf( fp, "chroots_iso=%s/cache/buildiso\n",  Config.path_cache_iso );
	fprintf( fp, "cache_dir=%s/cache/cache_dir\n",   Config.path_cache_iso );
	fprintf( fp, "chroots_dir=%s/cache/chroots_dir\n",  Config.path_cache_iso );
	if( TRUE == gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(GLADE_GET_OBJECT("radiobutton_iso_32_bits")) ))
		Config.choice_kernel_XX_bits = 32;	// arch=i686
	else
		Config.choice_kernel_XX_bits = 64;	// arch=x86_64
	fprintf( fp, "arch=%s\n",  Config.choice_kernel_XX_bits==32 ? "i686" : "x86_64" );
	fprintf( fp, "branch=%s\n",  gtk_combo_box_text_get_active_text( GTK_COMBO_BOX_TEXT(GLADE_GET_OBJECT("combobox_type_image")) ) );
	fprintf( fp, "dist_release=%s\n", NtbKernel_get_dist_release() );
	fclose( fp );
}
// 
// 
void NtbGenerate_timeout_end( void )
{
	// RESTORE ... /shared/isolinux
	gchar	*home_isolinux = g_strdup_printf("%s/shared/isolinux", Config.path_folder_manjaro_profiles );
	gchar	*home_save_isolinux = g_strdup_printf("%s/shared/save_isolinux", Config.path_folder_manjaro_profiles );
	libutils_remove_rep( home_isolinux );
	sleep( 1 );
	g_rename( home_save_isolinux, home_isolinux );
	g_free( home_isolinux );
	g_free( home_save_isolinux );
	
	// MANJARO-TOOLS.CONF
	// Restore file
	printf("%s*-*-> Restore file: %s%s\n", BOLD_YELLOW, VarGenerate.manjaro_tools_conf, RESET );
	libutils_copy_file_to(
			VarGenerate.manjaro_tools_conf_old,
			TRUE,
			VarGenerate.manjaro_tools_conf
			);
	
	// PROFIL.CONF
	// Restore file
	printf("%s*-*-> Restore file: %s%s\n", BOLD_YELLOW, VarGenerate.profil_conf, RESET );
	libutils_copy_file_to(
			VarGenerate.profil_conf_old,
			TRUE,
			VarGenerate.profil_conf
			);
	
	g_free( VarGenerate.manjaro_tools_conf );
	g_free( VarGenerate.manjaro_tools_conf_old );
	g_free( VarGenerate.profil_conf );
	g_free( VarGenerate.profil_conf_old );
	
	// DESKTOP
	// Restore file
	NtbPackage_restore_list();

	NtbHome_restore_datas_to_home_();

	gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_generate_iso_file")), TRUE );
}
// 
// 
void on_button_generate_iso_file_clicked( GtkButton *widget, gpointer user_data )
{
	printf("%s*-*-> on_button_generate_iso_file_clicked()%s\n", BOLD_GREEN, RESET );
	if( FALSE == libutils_access_web() ) {
			wind_info_init (
				WindMain_wind_main,
				_("A web connection is missing"),
				"\n",
				_("You need to enable web access"),
				"\n",
				"");
		printf("%s      test access web is bad :(%s\n", BOLD_RED, RESET );
		return;
	}
	printf("%s      test access web is ok%s\n", BOLD_YELLOW, RESET );

	gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_generate_iso_file")), FALSE );
	pulse_run(
		_("Generating the iso file, be patient ..."), // Génération du fichier iso, soyez patient
		NtbGenerate_timeout_begin,
		NtbGenerate_timeout_end,
		NtbGenerate_thread_iso_file
		);
}



/*
// ---------------------------------------------------------------------------
//  NTB_GENERATE.C
// ---------------------------------------------------------------------------
void NtbGenerate_quota_activate( void );
void NtbGenerate_quota_remove( void );


typedef struct {
	guint	handler_timeout;
} VAR_GENERATE;


// Tells the user the available space on mass media
// Indique à l'utilisateur la place disponible sur les supports de masse
static gint NtbGenerate_get_quota( gpointer data )
{
	FILE	*fp;
	gchar	buf[256];
	gint	line = 0;
	
	// 
	if( (fp = popen( "df -h", "r" )) == NULL ) { 
		perror( "popen error" );
		exit( 1 );
	}
	while( fgets( buf, sizeof(buf)-1, fp ) != NULL ) {
		if( 0 == line )
			printf("buf = %s", buf );
		else if( strncmp( "/dev/", buf, 5 ) == 0 )
			printf("buf = %s", buf );
		line ++;
	}
	pclose( fp );
	return( TRUE );
}
void NtbGenerate_quota_remove( void )
{
	g_source_remove( VarGenerate.handler_timeout );
}
void NtbGenerate_quota_activate( void )
{
	VarGenerate.handler_timeout = g_timeout_add( 5000, NtbGenerate_get_quota, 0 );
}



*/




